''' <summary>
''' Einge typsichere Liste, die beim Hinzufgen oder Entfernen von Objekte ein Changed-Event liefert
''' </summary>
''' <typeparam name="T">Typ der Objekte, die diese Liste enthlt</typeparam>
Public Class AddRemoveListe(Of T)
    Inherits List(Of T)
    Public Event Changed()
    Public Shadows Sub Add(ByVal item As T)
        MyBase.Add(item)
        RaiseEvent Changed()
    End Sub
    Public Shadows Sub AddRange(ByVal collection As IEnumerable(Of T))
        MyBase.AddRange(collection)
        RaiseEvent Changed()
    End Sub
    Public Shadows Sub Clear()
        MyBase.Clear()
        RaiseEvent Changed()
    End Sub
    Public Shadows Sub Insert(ByVal index As Integer, ByVal item As T)
        MyBase.Insert(index, item)
        RaiseEvent Changed()
    End Sub
    Public Sub InsertWithoutEvents(ByVal index As Integer, ByVal item As T)
        MyBase.Insert(index, item)
    End Sub
    Public Shadows Sub InsertRange(ByVal index As Integer, ByVal collection As IEnumerable(Of T))
        MyBase.InsertRange(index, collection)
        RaiseEvent Changed()
    End Sub
    Public Shadows Function Remove(ByVal item As T) As Boolean
        Dim result As Boolean = MyBase.Remove(item)
        RaiseEvent Changed()
        Return result
    End Function
    Public Sub RemoveAtWithoutEvents(ByVal index As Integer)
        MyBase.RemoveAt(index)
    End Sub
    Public Shadows Sub RemoveAt(ByVal index As Integer)
        MyBase.RemoveAt(index)
        RaiseEvent Changed()
    End Sub

End Class
