''' <summary>
''' Hilfsklasse, die das Umwandeln von Hexadezimal-Farbwerten in RGB-Farben und umgekehrt ermglicht
''' </summary>

Public Class HexColors
    ''' <summary>
    ''' Liefert fr einen Hexadezimal-String in eine Color-Struktur
    ''' </summary>
    ''' <param name="HexValue">Hexadezimal-String, der eine Farbe reprsentiert</param>
    ''' <returns>Color-Struktur</returns>
    Shared Function ToColor(ByVal HexValue As String) As Color
        Dim TmpText As String = HexValue.Trim
        Try
            If TmpText.Length = 3 Then
                Dim r As Integer, g As Integer, b As Integer
                r = Integer.Parse(TmpText.Substring(0, 1) & TmpText.Substring(0, 1), System.Globalization.NumberStyles.HexNumber)
                g = Integer.Parse(TmpText.Substring(1, 1) & TmpText.Substring(1, 1), System.Globalization.NumberStyles.HexNumber)
                b = Integer.Parse(TmpText.Substring(2, 1) & TmpText.Substring(2, 1), System.Globalization.NumberStyles.HexNumber)
                Return Color.FromArgb(r, g, b)
            ElseIf TmpText.Length = 6 Then
                Dim r As Integer, g As Integer, b As Integer
                r = Integer.Parse(TmpText.Substring(0, 2), System.Globalization.NumberStyles.HexNumber)
                g = Integer.Parse(TmpText.Substring(2, 2), System.Globalization.NumberStyles.HexNumber)
                b = Integer.Parse(TmpText.Substring(4, 2), System.Globalization.NumberStyles.HexNumber)
                Return Color.FromArgb(r, g, b)
            Else
                Throw New Exception("Unknown ColorString")
            End If
        Catch ex As Exception
            Throw New Exception("Unknown ColorString")
        End Try
    End Function
    ''' <summary>
    ''' Liefert fr eine Color-Struktur in einen Hexadezimal-String
    ''' </summary>
    ''' <param name="Color">Color-Struktur</param>
    ''' <returns>Hexadezimal-String, der eine Farbe reprsentiert</returns>
    Shared Function ToHexString(ByVal Color As Color) As String
        Dim red As String = Convert.ToString(Color.R, 16)
        red = red.PadLeft(2, "0")
        Dim green As String = Convert.ToString(Color.G, 16)
        green = green.PadLeft(2, "0")
        Dim blue As String = Convert.ToString(Color.B, 16)
        blue = blue.PadLeft(2, "0")
        Return red.ToUpper & green.ToUpper & blue.ToUpper
    End Function
End Class
