Imports System.ComponentModel
''' <summary>
''' Ein Control, mit dem man einen HSB-Farb-Wert anzeigen oder festlegen kann
''' </summary>
Public Class HSBControl
    Implements IColorControl

#Region " Private Felder / Events"
    'Event, das geliefert wird, wenn die ausgewhlte Farbe von "intern" gendert wurde
    Public Event ColorChanged(ByVal Sender As IColorControl) Implements IColorControl.ColorChanged
    Private m_Color As Color = Drawing.Color.Black
#End Region

#Region " Konstruktoren "
    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.Color = Drawing.Color.Red
    End Sub
#End Region

#Region " Properties "
    ''' <summary>
    ''' Color-Struktur, die angezeigt wird oder ausgewhlt ist
    ''' </summary>
    <Description("Die ausgewhlte Farbe"), _
    Category("ColorControl")> _
    Public Property Color() As System.Drawing.Color Implements IColorControl.Color
        Get
            Return m_Color
        End Get
        Set(ByVal value As System.Drawing.Color)
            If m_Color <> value Then
                m_Color = value
                Dim HSB As New HSLColor(m_Color)
                Me.TextBoxHue.ValidatedValue = (CInt(Math.Round(HSB.Hue * 360.0R))).ToString
                Me.TextBoxSat.ValidatedValue = (CInt(Math.Round(HSB.Saturation * 100.0R))).ToString
                Me.TextBoxBlack.ValidatedValue = (CInt(Math.Round(HSB.Lightness * 100.0R))).ToString
            End If
        End Set
    End Property
#End Region

#Region " Methoden "
    ''' <summary>
    ''' Interne Methode, die nach nderung in einer abhngigen ValidatedTextbox 
    ''' den eigenen Farbwert neu einstellt und das Changed-Event liefert
    ''' </summary>
    Private Sub NumericTextBox_ValidatedValue_Changed() Handles TextBoxHue.ValidatedValue_Changed, TextBoxSat.ValidatedValue_Changed, TextBoxBlack.ValidatedValue_Changed
        Dim hue As Double = CDbl(TextBoxHue.ValidatedValue) / 360.0R
        Dim sat As Double = CDbl(TextBoxSat.ValidatedValue) / 100.0R
        Dim lum As Double = CDbl(TextBoxBlack.ValidatedValue) / 100.0R
        Dim NewHSL As New HSLColor(hue, sat, lum)
        Dim NewColor As Color = NewHSL.ToRGB

        If m_Color <> NewColor Then
            m_Color = NewColor
            RaiseEvent ColorChanged(Me)
        End If
    End Sub
#End Region

End Class
