Imports System.ComponentModel
''' <summary>
''' Ein Control, mit dem man einen Hexadezimal-Farb-Wert anzeigen oder festlegen kann
''' </summary>
Public Class HexColorControl
    Implements IColorControl

#Region " Private Felder / Events"
    'Event, das geliefert wird, wenn die ausgewhlte Farbe von "intern" gendert wurde
    Public Event ColorChanged(ByVal Sender As IColorControl) Implements IColorControl.ColorChanged
    Private m_Color As Color = Drawing.Color.Black
#End Region

#Region " Konstruktoren "
    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.Color = Drawing.Color.Red
    End Sub
#End Region

#Region " Properties "
    ''' <summary>
    ''' Color-Struktur, die angezeigt wird oder ausgewhlt ist
    ''' </summary>
    <Description("Die ausgewhlte Farbe"), _
    Category("ColorControl")> _
    Public Property Color() As System.Drawing.Color Implements IColorControl.Color
        Get
            Return m_Color
        End Get
        Set(ByVal value As System.Drawing.Color)
            If m_Color <> value Then
                m_Color = value
                Me.HexColorTextBox1.ValidatedValue = HexColors.ToHexString(m_Color)
            End If
        End Set
    End Property
#End Region

#Region " Methoden "
    ''' <summary>
    ''' Interne Methode, die nach nderung in der abhngigen ValidatedTextbox 
    ''' den eigenen Farbwert neu einstellt und das Changed-Event liefert
    ''' </summary>
    Private Sub HexColorTextBox1_ValidatedValue_Changed() Handles HexColorTextBox1.ValidatedValue_Changed
        Dim Col As Color = HexColors.ToColor(HexColorTextBox1.ValidatedValue)
        If m_Color <> Col Then
            m_Color = Col
            RaiseEvent ColorChanged(Me)
        End If
    End Sub
#End Region

End Class
