Imports System.ComponentModel
''' <summary>
''' Ein Control, mit dem man einen RGB-Farb-Wert anzeigen oder festlegen kann
''' </summary>
Public Class RGBControl
    Implements IColorControl

#Region " Private Felder / Events"
    'Event, das geliefert wird, wenn die ausgewhlte Farbe von "intern" gendert wurde
    Public Event ColorChanged(ByVal Sender As IColorControl) Implements IColorControl.ColorChanged
    Private m_Color As Color = Drawing.Color.Black
#End Region

#Region " Konstruktoren "
    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.Color = Drawing.Color.Red
    End Sub
#End Region

#Region " Properties "
    ''' <summary>
    ''' Color-Struktur, die angezeigt wird oder ausgewhlt ist
    ''' </summary>
    <Description("Die ausgewhlte Farbe"), _
    Category("ColorControl")> _
    Public Property Color() As System.Drawing.Color Implements IColorControl.Color
        Get
            Return m_Color
        End Get
        Set(ByVal value As System.Drawing.Color)
            If m_Color <> value Then
                m_Color = value
                Me.TextBoxRed.ValidatedValue = m_Color.R.ToString
                Me.TextBoxGreen.ValidatedValue = m_Color.G.ToString
                Me.TextBoxBlue.ValidatedValue = m_Color.B.ToString
            End If
        End Set
    End Property
#End Region

#Region " Methoden "
    ''' <summary>
    ''' Interne Methode, die nach nderung in einer abhngigen ValidatedTextbox 
    ''' den eigenen Farbwert neu einstellt und das Changed-Event liefert
    ''' </summary>
    Private Sub NumericTextBox_ValidatedValue_Changed() Handles TextBoxRed.ValidatedValue_Changed, TextBoxGreen.ValidatedValue_Changed, TextBoxBlue.ValidatedValue_Changed
        Dim red As Integer = CInt(TextBoxRed.ValidatedValue)
        Dim green As Integer = CInt(TextBoxGreen.ValidatedValue)
        Dim blue As Integer = CInt(TextBoxBlue.ValidatedValue)
        Dim NewColor As Color = Drawing.Color.FromArgb(red, green, blue)
        If m_Color <> NewColor Then
            m_Color = NewColor
            RaiseEvent ColorChanged(Me)
        End If
    End Sub
#End Region

End Class
