Imports System.ComponentModel
''' <summary>
''' Ein TextBox-Control, das nur Eingabe hexadezimaler Farbwerte erlaubt
''' </summary>
Public Class HexColorTextBox
    Inherits ValidatedTextBox

#Region " berschriebene Properties "
    ''' <summary>
    ''' erlaubte Zeichen
    ''' </summary>
    Public Overrides ReadOnly Property AllowedChars() As String
        Get
            Return "1234567890ABCDEFabcdef"
        End Get
    End Property

    ''' <summary>
    ''' Valider Startwert
    ''' </summary>
    Public Overrides ReadOnly Property BaseValue() As String
        Get
            Return "FF0000"
        End Get
    End Property


#End Region

#Region " berschriebene Methoden "
    ''' <summary>
    ''' Methode, die fr den in der TextBox enthaltenen Text ein ValidatedValue-Objekt liefert
    ''' </summary>
    ''' <param name="TextBoxOriginal">Inhalt der TextBox vor Validierung</param>
    ''' <param name="LastValidatedValue">letzter gltiger (validierter) Inhalt der TextBox</param>
    ''' <remarks>ValidatedValue liefert Value(String) und gegebenenfalls Fehlermeldung</remarks>
    Public Overrides Function GetValideText(ByVal TextBoxOriginal As String, ByVal LastValidatedValue As String) As ValidatedValue
        Try
            Dim Col As Color = HexColors.ToColor(TextBoxOriginal)
            Dim ResultValue As String = HexColors.ToHexString(Col)
            Return New ValidatedValue(ResultValue, "")
        Catch ex As Exception
        End Try

        Return New ValidatedValue(LastValidatedValue, "Bitte einen gltigen Wert fr eine Hexadezimal-Farbe angeben." & Chr(10) & "Der nchstmgliche Wert wird eingesetzt.")
    End Function
#End Region

End Class
