Imports System.ComponentModel
''' <summary>
''' Demo-Form zur Auswahl eines Farbgradienten
''' </summary>
Public Class frm_GradientPicker

#Region " Private Felder / Events"
    'Gradient-Farbe
    Private m_Color As GradientColor
#End Region

#Region " Konstruktoren "

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

        ' Start-Gradient fr alle untergeordneten Controls festlegen
        m_Color = New GradientColor(Color.Red, Color.White, 0, 0)
        ReadColor()
    End Sub

#End Region

#Region " Properties "

    ''' <summary>
    ''' Gradient-Farbe
    ''' </summary>
    Property GradientColor() As GradientColor
        Get
            Return New GradientColor(m_Color)
        End Get
        Set(ByVal value As GradientColor)
            If value IsNot Nothing Then
                ' eigenen Start-Gradienten festlegen
                m_Color = New GradientColor(value)
                ' Start-Gradient fr alle untergeordneten Controls bernehmen
                ReadColor()
            End If
        End Set
    End Property

#End Region

#Region " Methoden "
    ''' <summary>
    ''' legt die anzuzeigenden Gradient-Inhalte fr alle untergeordneten Controls fest
    ''' </summary>
    Private Sub ReadColor()
        Me.ColorButton1.Color = m_Color.Color1
        Me.ColorButton2.Color = m_Color.Color2
        Me.GradientStyleSelector1.Color1 = m_Color.Color1
        Me.GradientStyleSelector1.Color2 = m_Color.Color2
        Me.GradientStyleSelector1.SelectedIndex = CInt(m_Color.GradientDirection) * 4 + CInt(m_Color.Variante)
        Me.GradientColorBox1.GradientColor = m_Color
    End Sub


    ''' <summary>
    ''' ndert die erste Farbe fr den Gradienten
    ''' </summary>
    Private Sub ColorButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ColorButton1.Click
        Dim frm As New frm_ColorPicker
        frm.Color = ColorButton1.Color
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            ColorButton1.Color = frm.Color
            m_Color.Color1 = frm.Color
            Me.GradientStyleSelector1.Color1 = m_Color.Color1
            Me.GradientColorBox1.GradientColor = m_Color
        End If
    End Sub

    ''' <summary>
    ''' ndert die zweite Farbe fr den Gradienten
    ''' </summary>
    Private Sub ColorButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ColorButton2.Click
        Dim frm As New frm_ColorPicker
        frm.Color = ColorButton2.Color
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            ColorButton2.Color = frm.Color
            m_Color.Color2 = frm.Color
            Me.GradientStyleSelector1.Color2 = m_Color.Color2
            Me.GradientColorBox1.GradientColor = m_Color
        End If
    End Sub

    ''' <summary>
    ''' bernimmt nderung des im GradientStyleSelector ausgewhlten Gradient-Stils
    ''' </summary>
    Private Sub GradientStyleSelector1_Changed() Handles GradientStyleSelector1.Changed
        m_Color.SetStyle(GradientStyleSelector1.GradientDirection, GradientStyleSelector1.Variante)
        Me.GradientColorBox1.GradientColor = m_Color
    End Sub
#End Region

End Class